/***************************************************************************
 *            gosmroute.h
 *
 *  Thu Jul 19 19:00:10 2007
 *  Copyright  2007  Steffen Pohle
 *  steffen@gulpe.de
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
#ifndef _GTK_PORT_H_
#define _GTK_PORT_H_

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "osmroute.h"
#include "map.h"

struct color {
	unsigned short int r;
	unsigned short int g;
	unsigned short int b;
	GdkColor c;
};


struct image {
	GdkPixmap *pixmap;
	GdkGC *gc;
	int width;
	int height;
};


#include "draw.h"

/***************************************************************
 * GTK internal functions, not for use in draw.h and stuff.
 */
extern GtkWidget *main_wnd;
extern GtkToggleAction *gpsenabled;
extern GtkWidget *positionlon, *positionlat;
extern int buttonpressed;

/*
 * map function and variables
 */
extern GtkWidget *map_da_create (); /* create drawarea */


/*
 * dialogs and stuff
 */
extern void gpssetting_wnd_show ();
extern char *dialog_getfilename (char *caption, char *filter, int save);


/* 
 * main window
 */
extern GtkWidget *main_wnd_create ();
extern GtkWidget *main_menu_create ();
extern void main_wnd_enable (int enabled);
extern void main_wnd_status (char *text, int progress);
extern void main_wnd_startall ();
extern void main_wnd_loop (int cur, int max);
extern void main_wnd_update ();
extern int gtk_running;

/*
 * other stuff
 */
extern void gui_enabled (int enabled);

#endif
