/***************************************************************************
 *            map_searchhash.c
 *
 *  Copyright  2010 - Steffen Pohle
 *  steffen@gulpe.de
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_LOCALE_H
  #include <locale.h>
#endif
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "map.h"
#include "memoryleak.h"
#include "system.h"


int map_search_fd = 0;


/****************************************************************************/
void map_search_get_filename (char *fn, int len);


/*****************************************************************************
 *
 * searching and filemanagment for the search files, this also includes
 * saving and reading files. All saved data will be in text format.
 * Country and Name will always be converted to lowercase text
 */
void map_search_get_filename (char *fn, int len) {
#ifdef HAVE_LOCALE_H
	setlocale(LC_ALL, "C");
	snprintf (fn, len, "%s/search.mapidx", datapath);
	setlocale(LC_ALL, NULL);
#else
	snprintf (fn, len, "%s/search.mapidx", datapath);
#endif	
};

void map_search_add (char *country, char *name, unsigned long long int id, float lon, float lat) {
	char *datablock = NULL;
	char dataline[MAP_SEARCHLINE_LEN];
	char fn[LEN_FILENAME];
	char *n, *c;
	char nullstring[2] = "\0\0";
	int size = 0;

	
	if (name == NULL) n = nullstring;
	else n = name;
	if (country == NULL) c = nullstring;
	else c = country;
	
	if (map_search_fd <= 0) {
		map_search_get_filename (fn, LEN_FILENAME);
		map_search_fd = open (fn, O_RDWR | O_CREAT, 0644);
	}
	
	if (map_search_fd) {
		lseek (map_search_fd, 0, SEEK_END);
		snprintf (dataline, MAP_SEARCHLINE_LEN, "%s\t%s\t%lld\t%f\t%f\n", c, n, id, lon, lat);
		write (map_search_fd, dataline, strlen (dataline));
	}
};


unsigned long long int map_search (char *country, char *name, float *reslon, float *reslat) {
};

