/***************************************************************************
 *            gosmroute.h
 *
 *  Thu Jul 19 19:00:10 2007
 *  Copyright  2007  Steffen Pohle
 *  steffen@gulpe.de
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _OSMROUTE_H_
#define _OSMROUTE_H_

#ifndef NOCONFIG
  #include <config.h>
#endif

#ifndef VERSION
  #define VERSION "0.0.1"
#endif

#if defined(__MINGW32CE__) || defined(_WIN32_WCE)
  #define _WINDOWSCE_
#endif

#ifdef __MINGW32__
  #define _WINDOWS_
#endif

#if !defined(__MINGW32CE__) && !defined(_WIN32_WCE) && !defined(__MINGW32__)
  #include <locale.h>
  #include <errno.h>
  #define _LINUX_
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*
 * Standard gettext macros.
 */
#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#define MAPDOWNLOAD_OSM 0
#define MAPDOWNLOAD_MAP 1

#define LEN_FILENAME 128

/*
 * debug
 */

#include "map.h"


enum {	/* what we're doing at the moment */
	APPSTATUS_nothing,
	APPSTATUS_loadfromweb,
	APPSTATUS_saveall
};


struct {
	int x;
	int y;
} typedef iPoint;


struct {
	float x;
	float y;
} typedef fPoint;


char datapath[LEN_FILENAME];
char cachepath[LEN_FILENAME];
char logpath[LEN_FILENAME];


extern void config_init ();
extern void config_draw_init ();
extern void config_draw_load (char *fn);
extern void config_load ();
extern void config_draw_save (char *fn);
extern void config_save ();


extern int app_status;
extern float debug_lon, debug_lat;

#ifdef GOSMROUTE
#include "gtk_port.h"
#endif

#ifdef WOSMROUTE
#include "wince_port.h"
#endif

#ifdef WCEOSMROUTE
#include "wince_port.h"
#endif

#ifdef OSM2MAP
#include "convert_port.h"
#endif

#ifdef COSMROUTE
#include "ncurses_port.h"
#endif


#endif
