/***************************************************************************
 *            vector.c
 *
 *  Copyright  2010 - Steffen Pohle
 *  steffen@gulpe.de
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "osmroute.h"
#include "vector.h"

fPoint vec_add (fPoint veca, fPoint vecb) {
	fPoint r;

	r.x = veca.x + vecb.x;
	r.y = veca.y + vecb.y;

	return r;	
};


fPoint vec_sub (fPoint veca, fPoint vecb) {
	fPoint r;

	r.x = veca.x - vecb.x;
	r.y = veca.y - vecb.y;

	return r;	
};


fPoint vec_normale (fPoint veca, fPoint vecb) {
	fPoint ret;
	fPoint veca0;
	float a, sklprd;

	/* get vector a */
	a = sqrt (veca.x * veca.x + veca.y * veca.y);
	veca0.x = veca.x / a;
	veca0.y = veca.y / a;

	/* scalarprodukt */
	sklprd = vecb.x * veca0.x + vecb.y * veca0.y;
	ret.x = sklprd * veca0.x;
	ret.y = sklprd * veca0.y;
	
	return ret;
};


